require 'rubygems'
require 'log4r'
require 'uri'
require 'net/http'
require 'net/https'
require 'time'
require 'base64'
require 'hmac-sha1'


Log4r::Logger.new('atmos')
Log4r::Logger.get('atmos').add(Log4r::StderrOutputter.new 'console')
Log4r::Logger.get('atmos').level = Log4r::FATAL
#Log4r::Logger.get('atmos').level = Log4r::WARN
#Log4r::Logger.get('atmos').level = Log4r::INFO
#Log4r::Logger.get('atmos').level = Log4r::DEBUG


$:.unshift(File.dirname(__FILE__))
require 'atmos/parser'
require 'atmos/version'
require 'atmos/util'
require 'atmos/exceptions'
require 'atmos/request'
require 'atmos/response'
require 'atmos/rest'
require 'atmos/store'
require 'atmos/attributes'
require 'atmos/object'

#
# This sets the default, but it can still be overridden by setting the parser elsewhere.
#
Atmos::Parser::parser = (File.exists?(File.join(File.dirname(__FILE__), 'atmos/parser/rexml.rb'))) ? Atmos::Parser::REXML : Atmos::Parser::NOKOGIRI
Atmos::LOG.warn("parser: #{Atmos::Parser::parser}")