module Atmos
   class Util # :nodoc:
            
      #
      # Utility method to convert from a standard Atmos key/value pair return header.
      #
      def self.header2hash(value)
         return nil if (value.nil?)
         raise Atmos::Exceptions::ArgumentException, "The 'value' parameter must be a String" if (!value.kind_of?(String))
         
         rv = {}
         if (!value.nil?)
            value.split(',').each do |elt|
               key,val = elt.split('=')
               rv[key.strip] = val.nil? ? "" : val.strip
            end
         end

         rv
      end
      
      
      #
      # Utility method to convert to a standard header value.
      #
      def self.hash2header(value)
         return nil if (value.nil?)
         raise Atmos::Exceptions::ArgumentException, "The 'value' parameter must be a Hash" if (!value.kind_of?(Hash))

         rv = ""
         if (!value.nil?)
            value.each do |k,v|
               rv += "#{k}=#{v}, "
            end
         end

         rv[0..-3]
      end
   end
end