module Atmos
  module Test
    class Util
      $stdout.sync = true
      @use_proxy = false
      @proxy = 'http://127.0.0.1:3128'
      @store = nil
      @server = :flintstones
      @servers =
        {:alma         => {
          :url         => 'https://10.5.113.71',
          :redirect_url=> nil,
          :version     => '2.0.1',
          :default_tag => 'atmos-ruby',
          :tenant      => '69eb3dc3bf9746f895d1ce12ae1d9589',
          :user        => 'dragaf-test',
          :group       => 'other',
          :secret      => 'p97mki4AkiAyVi+/7QpdxFAU/jY=',
          :other_user  => nil,
          :other_group => nil,
        },
        :flintstones   => {
          :url         => 'https://10.6.149.73',
          :redirect_url=> nil,
          :version     => '1.4.2',
          :default_tag => 'atmos-ruby',
          :tenant      => 'd492c5b4414943e182355c5a491b81fe',
          :user        => 'dragaf-test-main',
          :group       => 'other',
          :secret      => 'Cv7T7n/pXUCfkx9OlKsmTKBxAUw=',
          :other_user  => 'dragaf-test-other',
          :other_group => 'grouptest',
        },
        :atmosonline  => {
          :url         => 'https://accesspoint.atmosonline.com',
          :redirect_url=> 'http://accesspoint.atmosonline.com',
          :version     => '1.3.4',
          :default_tag => 'atmos-ruby',
          :tenant      => 'b245ad26f5c94bcbbaffa315a833f27a',
          :user        => 'A79755852684b2e05d00',
          :group       => 'other',
          :secret      => 'sM6oN/k6e03iW7lNSUzFav9rwck=',
          :other_user  => 'A797558526171ea693ce',
          :other_group => 'grouptest',
        },
        :cambridge_71 => {
          :url         => 'https://10.5.113.74',
          :redirect_url=> nil,
          :version     => '1.4.1',
          :default_tag => 'atmos-ruby',
          :tenant      => 'ab9090e754b549eeb460a468abdf7fc2',
          :user        => 'dragaf-test-tenant-user1',
          :group       => 'other',
          :secret      => 't5R1ftRNLXQ3ejv6fvJLNFMFrPo=',
          :other_user  => 'another',
          :other_group => nil,
        },
        :matt        => {
          :url         => 'http://137.69.164.126',
          :redirect_url=> nil,
          :version     => "1.4.0",
          :default_tag => 'atmos-ruby',
          #:tenant      => 'fdragan-atmos-ruby-test',
          :tenant      => '4aba2817d7eb4a2d93dfdccb3caedb9f',
          :user        => 'testuser02',
          :group       => 'other',
          :secret      => 'sWNxtrhorOpi0R3PNPSo1uKV4Vo=',
          :other_user  => 'testuser01',
          :other_group => nil,
        },
      }

      def self.parser_type
         Atmos::Parser::NOKOGIRI
         #Atmos::Parser::REXML
      end

      #
      # Provides the same store object to all who request it.
      # This is the default for running tests.  If tests fail
      # you can change the mode to get a new store each time
      # and see if that fixes it.  If so, you know that something
      # weird is going on with the Atmos::Store object.
      #
      def self.static_store
         if (@store.nil?)
            Atmos::Parser::parser = parser_type
            @store = Atmos::Store.new(:url    => url,
                                      :uid    => uid,
                                      :secret => secret,
                                      :proxy  => proxy
                                      )
        end

        return @store
      end

      def self.new_store
         Atmos::Parser::parser = parser_type
         Atmos::Store.new(:url    => url,
                          :uid    => uid,
                          :secret => secret,
                          :proxy  => proxy
                          )
      end


      def self.server
        @server
      end

      def self.use_proxy=(bool)
        @use_proxy = bool
      end

      def self.proxy
        (@use_proxy == true) ? @proxy : nil
      end

      def self.small_text_filename
        File.join(File.dirname(__FILE__),
                  'files/something.txt')
      end
         
      def self.small_binary_filename
        File.join(File.dirname(__FILE__),
                  'files/dragaf-tiny-from-vsphere.ova')
      end
         
      def self.large_binary_filename
        File.join(File.dirname(__FILE__),
                  'SmallImageForTest.iso')
      end
         
      def self.test_server_info(key)
        @servers[key]
      end

      def self.uid
        return "#{Atmos::Test::Util.tenant}/#{Atmos::Test::Util.user}"
      end

      def self.method_missing(sym, *args)
        if (@servers[@server].has_key?(sym))
          return @servers[@server][sym]
        else
          return super.method_missing(sym, *args)
        end
      end
            
    end
  end
end
