require 'credentials'
require 'test/unit'
require 'atmos'


class AtmosObjectUpdateTest < Test::Unit::TestCase

   def initialize(id)
      super(id)
      @cleanup = []
   end

   def setup
      @s   = Atmos::Test::Util.static_store
      @obj = @s.create
      @cleanup.push(@obj)
      #print "test_object_update.setup(): obj: #{@obj}; objid: #{@obj.aoid}\n"
   end


   def teardown
      @cleanup.each do |obj|
         obj.delete
      end
      $stdout.flush
   end

   def test_object_ok
      assert_not_nil(@obj)
      assert_equal({}, @obj.metadata)
      assert_equal({}, @obj.listable_metadata)
      assert_equal({Atmos::Test::Util.user => :full}, @obj.user_acl)
      assert_equal({Atmos::Test::Util.group => :none}, @obj.group_acl)
   end
      
   def test_update_empty_obj
      data = "Hello World"
      @obj.update(data)
      assert_equal(data, @obj.data)      
   end
   
 #  def test_append_non_empty_object
 #     data = @obj.data
 #     @obj.append("!")
 #     assert_equal(data+"!", @obj.data)
 #     print "appended hello world object with !: #{@obj.data}\n"
 #  end
   
   def test_update_object_in_place
      data = "Hello World!"
      @obj.update(data)
      assert_equal(data, @obj.data)
      
      range = 0..4
      @obj.update("Mad  ", range)
      assert_equal("Mad   World!", @obj.data)
   end
    
end
