require 'test/unit'
require 'atmos'


class AtmosUtilTest < Test::Unit::TestCase

   def setup
   end

   def teardown
      $stdout.flush
   end

   def test_hash2header_nil
      rv = Atmos::Util.hash2header(nil)
      assert_nil(rv)
   end
   
   def test_hash2header_empty
      rv = Atmos::Util.hash2header({})
      assert_equal("", rv)
   end
   
   def test_hash2header_bad_input_type
      assert_raise Atmos::Exceptions::ArgumentException do
         Atmos::Util.hash2header([])
      end
   end

   def test_hash2header
#      input = {:a=>:b, :x=>:y, 1=>1}
#      rv = Atmos::Util.hash2header(input)
#      assert_equal("a=b, x=y, 1=1", rv)
   end
   
   def test_header2hash_nil
      rv = Atmos::Util.header2hash(nil)
      assert_nil(rv)
   end
   
   def test_header2hash_empty
      rv = Atmos::Util.header2hash("")
      assert_equal({}, rv)
   end
   
   def test_header2hash_bad_input_type
      assert_raise Atmos::Exceptions::ArgumentException do
         Atmos::Util.header2hash([])
      end
   end
   
   def test_header2hash
      input = "a=b, x=y, 1=1"
      rv = Atmos::Util.header2hash(input)
      assert_equal({'a'=>'b', 'x'=>'y', '1'=>'1'}, rv)
   end
   
end